//2023314
#ifndef MPC_P2_H
#define MPC_P2_H

#ifdef DLL_EXPORT
#define DLL_API extern "C" _declspec(dllexport)
//			#define DLL_API  _declspec(dllexport)
#else
#define DLL_API extern "C" _declspec(dllimport)
//			#define DLL_API  _declspec(dllimport)
#endif

#define			CHAR8			char
#define			UCHAR8			unsigned char
#define			INT32			int
#define			UINT32			unsigned int

typedef struct WORK_STATUS_WORDS
{
	//ӹͨ1״̬  
	UINT32 bWorkPauseProcess_1 : 1; //ͨ1ͣ״̬
	UINT32 bWorkPauseDone_1 : 1; //ͨ1ֹͣͣ״̬
	UINT32 bWorkResumeProcess_1 : 1; //ͨ1ָ״̬
	UINT32 bCheckBatchDone1 : 1; //ͨ1ִָ״̬
   //ӹͨ2״̬
	UINT32 bWorkPauseProcess_2 : 1; //ͨ2ͣ״̬
	UINT32 bWorkPauseDone_2 : 1; //ͨ2ֹͣͣ״̬
	UINT32 bWorkResumeProcess_2 : 1; //ͨ2ָ״̬
	UINT32 bCheckBatchDone2 : 1; //ͨ2ִָ״̬
	//ӹͨ3״̬
	UINT32 bWorkPauseProcess_3 : 1; //ͨ3ͣ״̬
	UINT32 bWorkPauseDone_3 : 1; //ͨ3ֹͣͣ״̬
	UINT32 bWorkResumeProcess_3 : 1; //ͨ3ָ״̬
	UINT32 bCheckBatchDone3 : 1; //ͨ3ִָ״̬
   //ӹͨ4״̬
	UINT32 bWorkPauseProcess_4 : 1; //ͨ4ͣ״̬
	UINT32 bWorkPauseDone_4 : 1; //ͨ4ֹͣͣ״̬
	UINT32 bWorkResumeProcess_4 : 1; //ͨ4ָ״̬
	UINT32 bCheckBatchDone4 : 1; //ͨ4ִָ״̬
   //ʵʱ˶״̬
	UINT32 bAxis1RunStatus : 1; //1˶״̬
	UINT32 bAxis2RunStatus : 1; //2˶״̬
	UINT32 bAxis3RunStatus : 1; //3˶״̬
	UINT32 bAxis4RunStatus : 1; //4˶״̬
	UINT32 bAxis5RunStatus : 1; //5˶״̬
	UINT32 bAxis6RunStatus : 1; //6˶״̬
	UINT32 bAxis7RunStatus : 1; //7˶״̬
	UINT32 bAxis8RunStatus : 1; //8˶״̬
	UINT32 bAxis9RunStatus : 1; //9˶״̬
	UINT32 bAxis10RunStatus : 1; //10˶״̬ 
	UINT32 bAxis11RunStatus : 1; //11˶״̬ 
	UINT32 bAxis12RunStatus : 1; //12˶״̬ 
	UINT32 bAxis13RunStatus : 1; //13˶״̬ 
	UINT32 bAxis14RunStatus : 1; //14˶״̬ 
	UINT32 bReserved : 2;
}WorkStatesWords;

//״̬
typedef union WC_STATUS_WORDS
{
	UINT32 all;
	WorkStatesWords bit;
}WcStatesWords;

//״̬
typedef struct MC_ALL_STATES
{
	UINT32	VersionARM1APP;//arm1汾
	UINT32	VersionARM2APP;//arm2汾
	UINT32	VersionFpga;//fpga汾
	UINT32	VersionLinuxOs;
	UINT32	VersionIopNet;
	UCHAR8	ProductSNID[12]; //SNţ12λ
	UINT32	TimerAvailableDays;//ʱ䣬λ죬9999ʾƣ0-ʾѾ

	UINT32	PrivateAxesStatus;//ר״̬
	UINT32	MainInputState;
	UINT32	ExtendInputState[2];
	UINT32	MainOutputState;
	UINT32	ExtendOutputState[2];
	INT32	AxisPosPlus[10];
	INT32	AxisPosFeedback[10];
	UINT32	ErrorCodeArm0;
	UINT32	ErrorCodeArm1;
	UINT32	ProgressUpdateArm0;
	UINT32	ProgressUpdateArm1;
	INT32	AxisCaptureLock[10];
	WcStatesWords arm2Status;  //״̬
	UCHAR8  ProductRegSerialNo[20];//Ʒʱڼк
	UINT32  EncoderStatus;         //[29:20]:ECA [19:10]:ECB [9:0]:ECZ 1~10ı״̬,228  
	UINT32  ServoOutputStatus;     //ŷʹЧƽ-232
	UINT32 FifoDatasLeftover[4];//λñȽfifioʣDW -248
	INT32 ExAxisPosPlus[4];//չλ-264
}McAllStates;

//ӿ
DLL_API int api_get_lib_version(unsigned int* version);
DLL_API int open_api_record(int flag);

//ʼ
DLL_API	int init_api(const char * ipaddr = NULL, int port = 502, int timeout = 3000, int idMc = 0);
DLL_API int deinit_api(int idMc = 0);//Դͷ
DLL_API	int init_mc(char* ipAdd, int idMc = 0);
DLL_API int command_set_mc_ip_addr(unsigned char* ipAddr,int idMc = 0);

//״̬ȡָ
DLL_API int get_mc_all_states(McAllStates* mcStatus, int idMc = 0);

//ָ
DLL_API int begin_package_bat_cmd(int uCmdCh = 0, int idMc = 0);
DLL_API int end_package_bat_cmd(int uCmdCh = 0, int idMc = 0);

//չ
DLL_API int enable_exaxis(unsigned int exaxis, int uCmdCh = 0, int idMc = 0);
DLL_API int set_exaxis_channel(int ch, int channel, int uCmdCh = 0, int idMc = 0);

//ָ
DLL_API int switch_cmd_type(unsigned char cmdType, int uCmdCh = 0, int idMc = 0);
DLL_API int set_mc_error_code(int errorType, unsigned int errorcode, int idMc = 0);
DLL_API int set_axis_pulse_per_mm(unsigned char ch, float pulsePermm, int uCmdCh = 0, int idMc = 0);
DLL_API int set_axis_jerk_speed(unsigned char ch, float jerkSpeedMM, int uCmdCh = 0, int idMc = 0);
DLL_API int set_axis_max_speed(unsigned char ch,float maxSpeedMM, float maxAccSpeedMM, int uCmdCh = 0, int idMc = 0);
DLL_API int set_axis_private_input_level(unsigned char ch, int posElLevel, int negElLevel, int orgLevel, int alarmLevel, int uCmdCh = 0, int idMc = 0);
DLL_API int set_axis_private_output_level(unsigned char ch, int dirMotor, int enableMotor, int modePulse, int logicEdgePulse, int uCmdCh = 0, int idMc = 0);
DLL_API int set_axis_encode_param(unsigned char ch, int frequency, int encodeDir, int uCmdCh = 0, int idMc = 0);//ñƵ
DLL_API int enable_axis_servo_on(unsigned char ch, int enable, int uCmdCh = 0, int idMc = 0);
DLL_API int set_pulse_abs_pos(unsigned char ch, int absPos, int uCmdCh = 0, int idMc = 0);
DLL_API int set_encode_abs_pos(unsigned char ch, int encodeAbsPos, int uCmdCh = 0, int idMc = 0);
DLL_API int enable_axis_pulse_out(unsigned char ch, int enable, int uCmdCh = 0, int idMc = 0);
DLL_API int set_axis_stop_mode_el(unsigned char ch, int modeStop, int uCmdCh = 0, int idMc = 0);
DLL_API int set_profile(unsigned char ch, float startSpeedMM, float HighSpeedMM, float endSpeedMM, float accSpeedMM, int uCmdCh = 0, int idMc = 0);
DLL_API int set_profile_s(unsigned char ch, float startSpeedMM, float HighSpeedMM, float endSpeedMM, float accSpeedMM, float accaccSpeedMM, int uCmdCh = 0, int idMc = 0);
DLL_API int set_vector_profile(float startSpeedMM, float HighSpeedMM, float endSpeedMM, float accSpeedMM, int uCmdCh = 0, int idMc = 0);
DLL_API int set_vector_profile_s(float startSpeedMM, float HighSpeedMM, float endSpeedMM, float accSpeedMM, float accaccSpeedMM, int uCmdCh = 0, int idMc = 0);
DLL_API int c_set_track_speed(float startSpeedMM, float HighSpeedMM, float endSpeedMM, float accSpeedMM, int uCmdCh = 0, int idMc = 0);
DLL_API int set_arc_segment_dis(float arcSegmentDis, int uCmdCh = 0, int idMc = 0);
DLL_API int enable_axis_capture(int ch, int enable,int uCmdCh = 0, int idMc = 0);
DLL_API int set_axis_capture_source(int ch, int sourceType, int uCmdCh = 0, int idMc = 0);
DLL_API int clear_axis_capture_pos(int ch, int uCmdCh = 0, int idMc = 0);
DLL_API int config_position_compare_output(int ch, int source, int outMode, int initLevel, int pulseTimeUs, int modeDis, int uCmdCh = 0, int idMc = 0);
DLL_API int set_compare_link_output(int outputIndex, int enable, int uCmdCh =0, int idMc =0);
DLL_API int write_compare_position(int startIndex, int* listCompareDis, int counter, int uCmdCh = 0, int idMc = 0);
DLL_API int set_compare_counter(int counterCompare, int uCmdCh = 0, int idMc = 0);
DLL_API int enable_postion_compare(int enable, int uCmdCh = 0, int idMc = 0);
DLL_API int set_channel_work_axis_group(unsigned int workAxis, unsigned int linkAxis, int axisX, int uCmdCh = 0, int idMc = 0);
DLL_API int set_input_level(unsigned int mainMask, unsigned int mainInputLevel, unsigned int extendMask, unsigned int extendInputLevel,
		unsigned int smcMask, unsigned int smcInputLevel, int uCmdCh = 0, int idMc = 0);
DLL_API int set_pause_outports_ctrl(unsigned int mainBoardMask, unsigned int mainBoardState, unsigned int extendBoardMask,
		unsigned int extendBoardState, unsigned int smcBoardMask, unsigned int smcBoardState, int uCmdCh = 0, int idMc = 0);

//ָ
DLL_API int outport_bit(int portIndex, int state, int uCmdCh = 0, int idMc = 0);
DLL_API int outport_byte(unsigned int mainBoardPorts, unsigned int mainBoardState,unsigned int extendBoardPorts, 
	unsigned int extendBoardState,	unsigned int smcBoardPorts, unsigned int smcBoardState,int uCmdCh = 0, int idMc = 0);
DLL_API int lag_outport_bit(int portIndex, int state,int lagTimeMs, int uCmdCh = 0, int idMc = 0);
DLL_API int lag_outport_byte(unsigned int mainBoardPorts, unsigned int mainBoardState, unsigned int extendBoardPorts,
	unsigned int extendBoardState, unsigned int smcBoardPorts, unsigned int smcBoardState, int lagTimeMs, int uCmdCh = 0, int idMc = 0);
DLL_API int motion_pause(int uCmdCh = 0, int idMc = 0);
DLL_API int motion_resume(int uCmdCh = 0, int idMc = 0);
DLL_API int axis_decel_stop(int ch, int isImmCmd = 1, int uCmdCh = 0, int idMc = 0);
DLL_API int axis_sudden_stop(int ch, int isImmCmd = 1, int uCmdCh = 0, int idMc = 0);
DLL_API int motion_sudden_stop(int uCmdCh = 0, int idMc = 0);
DLL_API int motion_decel_stop(int uCmdCh = 0, int idMc = 0);
DLL_API int change_axis_speed(int ch, float speedNewMM, int uCmdCh = 0, int idMc = 0);
DLL_API int c_change_track_speed(float speedNew, int uCmdCh = 0, int idMc = 0);
DLL_API int enable_axis_el(int ch, int elPorN, int enable, int uCmdCh = 0, int idMc = 0);
DLL_API int enable_axis_alarm(int ch,int enable, int uCmdCh = 0, int idMc = 0);
DLL_API int delay_time(int delayMs, int uCmdCh = 0, int idMc = 0);
DLL_API int wait_inport_condition(int inportsIndex, int waitStatus, int timeOutMs = 0, int timeOutErrorCode = 0, int uCmdCh = 0, int idMc = 0);


//䷧ָ
DLL_API int config_jet_ports(int portsBits, int uCmdCh = 0, int idMc = 0);
DLL_API int config_track_jet(int mode, int source, int offset, int uCmdCh = 0, int idMc = 0);
DLL_API int set_jet_track_params(int openTimeUs, int closeTimeUs, float disDots, int uCmdCh = 0, int idMc = 0);
DLL_API int change_jet_track_dis(float disDots, int uCmdCh = 0, int idMc = 0);
DLL_API int start_points_jet(int openTimeUs, int closeTimeUs, int counterDots, int uCmdCh = 0, int idMc = 0);
DLL_API int start_track_jet(int uCmdCh = 0, int idMc = 0);
DLL_API int stop_jet(int uCmdCh = 0, int idMc = 0);
DLL_API int wait_jet_done(int uCmdCh = 0, int idMc = 0);
DLL_API int set_compare_datas(int dotCount, int* dotPos, int uCmdCh = 0, int idMc = 0);
DLL_API int reset_compare_datas(int uCmdCh = 0, int idMc = 0);

//˶ָ
DLL_API int curve_begin(int uCmdCh = 0, int idMc = 0);
DLL_API int curve_end(int uCmdCh = 0, int idMc = 0);
DLL_API int fast_line_ex(int *idxs, int *steps,int axis_count, float vectorLength = -1.0f, int uCmdCh = 0, int idMc = 0);
DLL_API int fast_line2(int ch1, int dis1, int ch2, int dis2, float vectorLength = -1.0f, int uCmdCh = 0, int idMc = 0);
DLL_API int fast_line3(int ch1, int dis1, int ch2, int dis2, int ch3, int dis3, float vectorLength = -1.0f, int uCmdCh = 0, int idMc = 0);
DLL_API int fast_line4(int ch1, int dis1, int ch2, int dis2, int ch3, int dis3, int ch4, int dis4, float vectorLength = -1.0f, int uCmdCh = 0, int idMc = 0);
DLL_API int fast_line5(int ch1, int dis1, int ch2, int dis2, int ch3, int dis3, int ch4, int dis4, int ch5, int dis5, float vectorLength = -1.0f, int uCmdCh = 0, int idMc = 0);
DLL_API int fast_line6(int ch1, int dis1, int ch2, int dis2, int ch3, int dis3, int ch4, int dis4, int ch5, int dis5, int ch6, int dis6, float vectorLength=-1.0f, int uCmdCh=0, int idMc=0);
DLL_API int fast_arc_center(int ch1, int ch2, int ch3,  int disArcNode1, int disArcNode2, int disArcNode3,	int disArcEnd1, int disArcEnd2, int disArcEnd3, int uCmdCh = 0, int idMc = 0);
DLL_API int fast_arc_circle(int ch1, int ch2, int ch3, int disArcNode1, int disArcNode2, int disArcNode3, int disArcEnd1, int disArcEnd2, int disArcEnd3, int uCmdCh = 0, int idMc = 0);

//ָ޷ǰհ
DLL_API int fast_abs_line2(int ch1, int dis1, int ch2, int dis2, int uCmdCh = 0, int idMc = 0);
DLL_API int fast_abs_line3(int ch1, int dis1, int ch2, int dis2, int ch3, int dis3, int uCmdCh = 0, int idMc = 0);
DLL_API int fast_abs_line4(int ch1, int dis1, int ch2, int dis2, int ch3, int dis3, int ch4, int dis4, int uCmdCh = 0, int idMc = 0);
DLL_API int fast_abs_line5(int ch1, int dis1, int ch2, int dis2, int ch3, int dis3, int ch4, int dis4, int ch5, int dis5, int uCmdCh = 0, int idMc = 0);
DLL_API int fast_pmove(int ch1, int dis1,int isWaitDoneThenNextCmd =1, int uCmdCh = 0, int idMc = 0);
DLL_API int fast_pmove2(int ch1, int dis1, int ch2, int dis2, int isWaitDoneThenNextCmd = 1, int uCmdCh = 0, int idMc = 0);
DLL_API int fast_pmove3(int ch1, int dis1, int ch2, int dis2, int ch3, int dis3, int isWaitDoneThenNextCmd = 1, int uCmdCh = 0, int idMc = 0);
DLL_API int fast_pmove4(int ch1, int dis1, int ch2, int dis2, int ch3, int dis3, int ch4, int dis4, int isWaitDoneThenNextCmd = 1, int uCmdCh = 0, int idMc = 0);
DLL_API int fast_pmove5(int ch1, int dis1, int ch2, int dis2, int ch3, int dis3, int ch4, int dis4, int ch5, int dis5, int isWaitDoneThenNextCmd = 1, int uCmdCh = 0, int idMc = 0);
DLL_API int fast_abs_pmove(int ch1, int dis1, int isWaitDoneThenNextCmd = 1, int uCmdCh = 0, int idMc = 0);
DLL_API int fast_abs_pmove2(int ch1, int dis1, int ch2, int dis2, int isWaitDoneThenNextCmd = 1, int uCmdCh = 0, int idMc = 0);
DLL_API int fast_abs_pmove3(int ch1, int dis1, int ch2, int dis2, int ch3, int dis3, int isWaitDoneThenNextCmd = 1, int uCmdCh = 0, int idMc = 0);
DLL_API int fast_abs_pmove4(int ch1, int dis1, int ch2, int dis2, int ch3, int dis3, int ch4, int dis4, int isWaitDoneThenNextCmd = 1, int uCmdCh = 0, int idMc = 0);
DLL_API int fast_abs_pmove5(int ch1, int dis1, int ch2, int dis2, int ch3, int dis3, int ch4, int dis4, int ch5, int dis5, int isWaitDoneThenNextCmd = 1, int uCmdCh = 0, int idMc = 0);
DLL_API int fast_line2_s(int ch1, int dis1, int ch2, int dis2, float vectorLength = -1.0f, int uCmdCh = 0, int idMc = 0);
DLL_API int fast_line3_s(int ch1, int dis1, int ch2, int dis2, int ch3, int dis3, float vectorLength = -1.0f, int uCmdCh = 0, int idMc = 0);
DLL_API int fast_line4_s(int ch1, int dis1, int ch2, int dis2, int ch3, int dis3, int ch4, int dis4, float vectorLength = -1.0f, int uCmdCh = 0, int idMc = 0);
DLL_API int fast_line5_s(int ch1, int dis1, int ch2, int dis2, int ch3, int dis3, int ch4, int dis4, int ch5, int dis5, float vectorLength = -1.0f, int uCmdCh = 0, int idMc = 0);
DLL_API int fast_abs_line2_s(int ch1, int dis1, int ch2, int dis2, int uCmdCh = 0, int idMc = 0);
DLL_API int fast_abs_line3_s(int ch1, int dis1, int ch2, int dis2, int ch3, int dis3, int uCmdCh = 0, int idMc = 0);
DLL_API int fast_abs_line4_s(int ch1, int dis1, int ch2, int dis2, int ch3, int dis3, int ch4, int dis4, int uCmdCh = 0, int idMc = 0);
DLL_API int fast_abs_line5_s(int ch1, int dis1, int ch2, int dis2, int ch3, int dis3, int ch4, int dis4, int ch5, int dis5, int uCmdCh = 0, int idMc = 0);
DLL_API int fast_pmove_s(int ch1, int dis1, int isWaitDoneThenNextCmd = 1, int uCmdCh = 0, int idMc = 0);
DLL_API int fast_pmove2_s(int ch1, int dis1, int ch2, int dis2, int isWaitDoneThenNextCmd = 1, int uCmdCh = 0, int idMc = 0);
DLL_API int fast_pmove3_s(int ch1, int dis1, int ch2, int dis2, int ch3, int dis3, int isWaitDoneThenNextCmd = 1, int uCmdCh = 0, int idMc = 0);
DLL_API int fast_pmove4_s(int ch1, int dis1, int ch2, int dis2, int ch3, int dis3, int ch4, int dis4, int isWaitDoneThenNextCmd = 1, int uCmdCh = 0, int idMc = 0);
DLL_API int fast_pmove5_s(int ch1, int dis1, int ch2, int dis2, int ch3, int dis3, int ch4, int dis4, int ch5, int dis5, int isWaitDoneThenNextCmd = 1, int uCmdCh = 0, int idMc = 0);
DLL_API int fast_abs_pmove_s(int ch1, int dis1, int isWaitDoneThenNextCmd = 1, int uCmdCh = 0, int idMc = 0);
DLL_API int fast_abs_pmove2_s(int ch1, int dis1, int ch2, int dis2, int isWaitDoneThenNextCmd = 1, int uCmdCh = 0, int idMc = 0);
DLL_API int fast_abs_pmove3_s(int ch1, int dis1, int ch2, int dis2, int ch3, int dis3, int isWaitDoneThenNextCmd = 1, int uCmdCh = 0, int idMc = 0);
DLL_API int fast_abs_pmove4_s(int ch1, int dis1, int ch2, int dis2, int ch3, int dis3, int ch4, int dis4, int isWaitDoneThenNextCmd = 1, int uCmdCh = 0, int idMc = 0);
DLL_API int fast_abs_pmove5_s(int ch1, int dis1, int ch2, int dis2, int ch3, int dis3, int ch4, int dis4, int ch5, int dis5, int isWaitDoneThenNextCmd = 1, int uCmdCh = 0, int idMc = 0);
DLL_API int fast_hmove(unsigned char ch, unsigned char dir, int uCmdCh = 0, int idMc = 0);
DLL_API int fast_hmove_multi(unsigned int axisHome, unsigned int axisDir, int uCmdCh = 0, int idMc = 0);
DLL_API int fast_hmove_by_z_encoder(unsigned char ch, unsigned char dir, int uCmdCh = 0, int idMc = 0);
DLL_API int fast_hmove_multi_by_z_encoder(unsigned int axisHome, unsigned int axisDir, int uCmdCh = 0, int idMc = 0);

//ǿָ
DLL_API int imm_set_profile(unsigned char ch, float startSpeedMM, float HighSpeedMM, float endSpeedMM, float accSpeedMM, int idMc = 0);
DLL_API int imm_set_profile_s(unsigned char ch, float startSpeedMM, float HighSpeedMM, float endSpeedMM, float accSpeedMM, float accaccSpeedMM, int idMc = 0);
DLL_API int imm_fast_pmove(int ch1, int dis1, int idMc = 0);
DLL_API int imm_fast_pmove_s(int ch1, int dis1, int idMc = 0);
DLL_API int imm_outport_byte(unsigned int mainBoardPorts, unsigned int mainBoardState,unsigned int extendBoardPorts, unsigned int extendBoardState, unsigned int smcBoardPorts, unsigned int smcBoardState, int idMc = 0);
DLL_API int imm_outport_bit(int portIndex, int state, int idMc = 0);
DLL_API int imm_config_jet_ports(int portsBits, int uCmdCh = 0, int idMc = 0);
DLL_API int imm_start_points_jet(int openTimeUs, int closeTimeUs, int counterDots, int uCmdCh = 0, int idMc = 0);
DLL_API int imm_stop_jet(int uCmdCh = 0, int idMc = 0);

#endif
